; ===============================================================
; Multithread
; ===============================================================

.module Program
.export

Main
	; Groovy multithreading library
	.include "Multithread/Multithread.asm"


	; Kick things into action.
	call Multithread.Init
	
	
	; For the moment, the secondary thread is hard-coded, and 
	; the 'multithreading' code ONLY switches back and forth between
	; two hard-coded thread slots.
-
	ld b,8
	call ionRandom
	ld (curCol),a

	ld b,8
	call ionRandom
	ld (curRow),a

	ld b,0
	call ionRandom
	bcall(_PutMap)
	bcall(_getCSC)
	
	cp sk2nd
	jr nz,{+}
	
	ld hl,SecondaryThread
	ld bc,400
	call Multithread.Thread.Start
	xor a
	
+
	
	cp skClear
	jr nz,{-}
	
	; Once _GetKey finally 'gets' a key, clean up.
	call Multithread.End
	ret

	
; ---------------------------------------------------------
	
SecondaryThread
	
	di ; Don't want any other thread writing to the LCD!
	
			
	ld b,64
	call ionRandom
	add a,$80
	push af ; Save for later...
		out ($10),a
		
		ld b,48
		call ionRandom
		add a,48
		ld b,a
		srl a
		srl a
		srl a
		add a,$20
		out ($10),a
	
		ld a,b
		and 7
		ld c,%10000000
		jr z,{+}
		ld b,a
	-	srl c
		djnz {-}
	+
	
		in a,($11)
		call LcdBusy
		in a,($11)
		xor c
		ld c,a

		call LcdBusy

	pop af
	out ($10),a

	call LcdBusy
	ld a,c
	out ($11),a			
		
	ei
	
	jr SecondaryThread
	
LcdBusy
	push af
	inc hl
	dec hl
	pop af
	ret
		
.endmodule